
public class BinBaum {
    // Attribute
    Baumelement wurzel;
    
    //Konstruktor
    public BinBaum() {
        wurzel = new Abschluss();
    }

    //Methoden und Dienste
    /*
     * Die Methode insert baut gleich einen Suchbaum auf,
     * d.h. die Kindsknoten eines Knoten werden so angefgt,
     * das der linke Kindsknoten kleiner als der Wurzel
     * ist und der rechte Kindsknoten grer. Bei gleichen Elementen
     * wird nichts eingefgt.
     */
    public void insert(int newDaten) {
        wurzel = wurzel.insert(newDaten);
    }
    
    public void delete(int daten) {
        wurzel = wurzel.delete(daten);
    }
    
    /*
     * inorder gibt einen binren Suchbaum immer aufsteigender Reihenfolge aus
     */
    public void inorder() {
        wurzel.inorder();
    }

    public void postorder() {
        wurzel.postorder();
    }

    public void preorder() {
        wurzel.preorder();
    }
    
    public boolean suchen(int zahl) {
        return wurzel.suchen(zahl);
    }

    public int tiefe() {
        return wurzel.tiefe();
    }

    public Baumelement getRoot() {
        return wurzel;
    }
    
    public int getMin() {
        if (wurzel.istKnoten())
            return wurzel.getMin(((Knoten)wurzel).daten);
        return 0;
    }
    
    public int getKnotenSumme() {
        return wurzel.getKnotenSumme();
    }

    public void draw() {
        MainWindow currMainWindow = MainWindow.getMainWindow();
        currMainWindow.drawTree(this, wurzel.tiefe());
    }
    
}
